#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include	"devtab.h"

Dev	devtab[]={
	{ rootreset, rootinit, rootattach, rootclone, rootwalk, rootstat, rootopen, rootcreate,
	  rootclose, rootread, rootwrite, rootremove, rootwstat, },
	{ consreset, consinit, consattach, consclone, conswalk, consstat, consopen, conscreate,
	  consclose, consread, conswrite, consremove, conswstat, },
	{ envreset, envinit, envattach, envclone, envwalk, envstat, envopen, envcreate,
	  envclose, envread, envwrite, envremove, envwstat, },
	{ mntreset, mntinit, mntattach, mntclone, mntwalk, mntstat, mntopen, mntcreate,
	  mntclose, mntread, mntwrite, mntremove, mntwstat, },
	{ bitreset, bitinit, bitattach, bitclone, bitwalk, bitstat, bitopen, bitcreate,
	  bitclose, bitread, bitwrite, bitremove, bitwstat, },
	{ uartreset, uartinit, uartattach, uartclone, uartwalk, uartstat, uartopen, uartcreate,
	  uartclose, uartread, uartwrite, uartremove, uartwstat, },
	{ pipereset, pipeinit, pipeattach, pipeclone, pipewalk, pipestat, pipeopen, pipecreate,
	  pipeclose, piperead, pipewrite, piperemove, pipewstat, },
	{ floppyreset, floppyinit, floppyattach, floppyclone, floppywalk, floppystat, floppyopen, floppycreate,
	  floppyclose, floppyread, floppywrite, floppyremove, floppywstat, },
	{ atareset, atainit, ataattach, ataclone, atawalk, atastat, ataopen, atacreate,
	  ataclose, ataread, atawrite, ataremove, atawstat, },
	{ srvreset, srvinit, srvattach, srvclone, srvwalk, srvstat, srvopen, srvcreate,
	  srvclose, srvread, srvwrite, srvremove, srvwstat, },
	{ dupreset, dupinit, dupattach, dupclone, dupwalk, dupstat, dupopen, dupcreate,
	  dupclose, dupread, dupwrite, dupremove, dupwstat, },
	{ procreset, procinit, procattach, procclone, procwalk, procstat, procopen, proccreate,
	  procclose, procread, procwrite, procremove, procwstat, },
	{ rtcreset, rtcinit, rtcattach, rtcclone, rtcwalk, rtcstat, rtcopen, rtccreate,
	  rtcclose, rtcread, rtcwrite, rtcremove, rtcwstat, },
	{ dkreset, dkinit, dkattach, dkclone, dkwalk, dkstat, dkopen, dkcreate,
	  dkclose, dkread, dkwrite, dkremove, dkwstat, },
	{ lptreset, lptinit, lptattach, lptclone, lptwalk, lptstat, lptopen, lptcreate,
	  lptclose, lptread, lptwrite, lptremove, lptwstat, },
	{ etherreset, etherinit, etherattach, etherclone, etherwalk, etherstat, etheropen, ethercreate,
	  etherclose, etherread, etherwrite, etherremove, etherwstat, },
	{ ipreset, ipinit, ipattach, ipclone, ipwalk, ipstat, ipopen, ipcreate,
	  ipclose, ipread, ipwrite, ipremove, ipwstat, },
	{ arpreset, arpinit, arpattach, arpclone, arpwalk, arpstat, arpopen, arpcreate,
	  arpclose, arpread, arpwrite, arpremove, arpwstat, },
	{ iproutereset, iprouteinit, iprouteattach, iprouteclone, iproutewalk, iproutestat, iprouteopen, iproutecreate,
	  iprouteclose, iprouteread, iproutewrite, iprouteremove, iproutewstat, },
	{ vgareset, vgainit, vgaattach, vgaclone, vgawalk, vgastat, vgaopen, vgacreate,
	  vgaclose, vgaread, vgawrite, vgaremove, vgawstat, },
	{ audioreset, audioinit, audioattach, audioclone, audiowalk, audiostat, audioopen, audiocreate,
	  audioclose, audioread, audiowrite, audioremove, audiowstat, },
	{ scsireset, scsiinit, scsiattach, scsiclone, scsiwalk, scsistat, scsiopen, scsicreate,
	  scsiclose, scsiread, scsiwrite, scsiremove, scsiwstat, },
	{ wrenreset, wreninit, wrenattach, wrenclone, wrenwalk, wrenstat, wrenopen, wrencreate,
	  wrenclose, wrenread, wrenwrite, wrenremove, wrenwstat, },
	{ cdromreset, cdrominit, cdromattach, cdromclone, cdromwalk, cdromstat, cdromopen, cdromcreate,
	  cdromclose, cdromread, cdromwrite, cdromremove, cdromwstat, },
	{ i82365reset, i82365init, i82365attach, i82365clone, i82365walk, i82365stat, i82365open, i82365create,
	  i82365close, i82365read, i82365write, i82365remove, i82365wstat, },
	{ sbcdreset, sbcdinit, sbcdattach, sbcdclone, sbcdwalk, sbcdstat, sbcdopen, sbcdcreate,
	  sbcdclose, sbcdread, sbcdwrite, sbcdremove, sbcdwstat, },
};
Rune *devchar=L"/ceMbt|fHsdprkLlIaPvASwRym";
extern Qinfo perminfo;
extern void	stfcalllink(void);
extern void	stiplink(void);
extern void	stasynclink(void);
extern void	sturplink(void);
extern void	ether509link(void);
extern void	ether2000link(void);
extern void	ether4100link(void);
extern void	ether8003link(void);
extern void	vgaark2000pvlink(void);
extern void	vgaclgd542xlink(void);
extern void	vgact65540link(void);
extern void	vgaet4000link(void);
extern void	vgamach32link(void);
extern void	vgargb524link(void);
extern void	vgas3link(void);
extern void	vgabt485link(void);
extern void	vgatvp3020link(void);
void streaminit(void){
	newqinfo(&perminfo);
	stfcalllink();
	stiplink();
	stasynclink();
	sturplink();
	ether509link();
	ether2000link();
	ether4100link();
	ether8003link();
	vgaark2000pvlink();
	vgaclgd542xlink();
	vgact65540link();
	vgaet4000link();
	vgamach32link();
	vgargb524link();
	vgas3link();
	vgabt485link();
	vgatvp3020link();
}
	int cpuserver = 0;
	void consdebug(void){}
	int incondev = 0;
char	*conffile = "pc";
ulong	kerndate = KERNDATE;
